diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index 2e6fdd9ad..09e969d47 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -26,6 +26,10 @@ public class BlockLogicRepeater extends BlockLogic
     };
     public static final int MASK_DIRECTION = 0b0000_0011;
     public static final int MASK_TICK_DELAY = 0b0000_1100;
+    public static final int DIRECTION_SOUTH = 0;
+    public static final int DIRECTION_WEST = 1;
+    public static final int DIRECTION_NORTH = 2;
+    public static final int DIRECTION_EAST = 3;
 
     public final boolean isRepeaterPowered;
 
@@ -87,6 +91,23 @@ public class BlockLogicRepeater extends BlockLogic
         }
     }
 
+    // Ensure that repeaters can activate doors, tnt, and other redstone components through powering a neighboring block.
+    @Override
+    public boolean isSignalSource() {
+        return true;
+    }
+
+    // Cause block updates on the target block when removing a repeater,
+    // which prevents redstone components on the other wide of the target block from staying powered.
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        Side front = getSideFromMeta(data);
+        world.notifyBlocksOfNeighborChange(x + front.getOffsetX(), y + front.getOffsetY(), z + front.getOffsetZ(), id());
+        Side back = front.getOpposite();
+        world.notifyBlocksOfNeighborChange(x + back.getOffsetX(), y + back.getOffsetY(), z + back.getOffsetZ(), id());
+    }
+
+
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
         return getSignal(world, x, y, z, side);
@@ -98,16 +119,22 @@ public class BlockLogicRepeater extends BlockLogic
             return false;
         }
         int meta = worldSource.getBlockMetadata(x, y, z) & MASK_DIRECTION;
-        if(meta == 0 && side == Side.SOUTH) {
-            return true;
-        }
-        if(meta == 1 && side == Side.WEST) {
-            return true;
-        }
-        if(meta == 2 && side == Side.NORTH) {
-            return true;
+        return side == getSideFromMeta(meta);
+    }
+
+    public static Side getSideFromMeta(final int meta) {
+        switch (meta & 0b11) {
+            case DIRECTION_SOUTH:
+                return Side.SOUTH;
+            case DIRECTION_WEST:
+                return Side.WEST;
+            case DIRECTION_NORTH:
+                return Side.NORTH;
+            case DIRECTION_EAST:
+                return Side.EAST;
+            default:
+                throw new RuntimeException("No side for direction " + (meta & 0b11) + "!");
         }
-        return meta == 3 && side == Side.EAST;
     }
 
     @Override
@@ -129,20 +156,19 @@ public class BlockLogicRepeater extends BlockLogic
 
     private boolean isGettingPower(World world, int x, int y, int z, int meta)
     {
-        int direction = meta & MASK_DIRECTION;
-        switch(direction)
-        {
-        case 0: // '\0'
-            return world.getSignal(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z + 1) > 0;
+        Side direction = getSideFromMeta(meta);
+        switch(direction) {
+            case SOUTH:
+                return world.getSignal(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z + 1) > 0;
 
-        case 2: // '\002'
-            return world.getSignal(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z - 1) > 0;
+            case NORTH:
+                return world.getSignal(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z - 1) > 0;
 
-        case 3: // '\003'
-            return world.getSignal(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x + 1, y, z) > 0;
+            case EAST:
+                return world.getSignal(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x + 1, y, z) > 0;
 
-        case 1: // '\001'
-            return world.getSignal(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x - 1, y, z) > 0;
+            case WEST:
+                return world.getSignal(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x - 1, y, z) > 0;
         }
         return false;
     }
@@ -218,35 +244,35 @@ public class BlockLogicRepeater extends BlockLogic
         final int redstoneBrightness = 15;
 		
 		if (rand.nextInt(2) == 0) {
-			switch (meta & MASK_DIRECTION) {
-			case 0:
-				zOffset = -0.3125D;
-				break;
-			case 2:
-				zOffset = 0.3125D;
-				break;
-			case 3:
-				xOffset = -0.3125D;
-				break;
-			case 1:
-				xOffset = 0.3125D;
-				break;
+			switch (getSideFromMeta(meta)) {
+                case SOUTH:
+				    zOffset = -0.3125D;
+				    break;
+                case NORTH:
+				    zOffset = 0.3125D;
+				    break;
+                case EAST:
+				    xOffset = -0.3125D;
+				    break;
+                case WEST:
+				    xOffset = 0.3125D;
+				    break;
 			}
 		} else {
 			int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
-			switch (meta & MASK_DIRECTION) {
-			case 0:
-				zOffset = torchPosOffset[tickDelay];
-				break;
-			case 2:
-				zOffset = -torchPosOffset[tickDelay];
-				break;
-			case 3:
-				xOffset = torchPosOffset[tickDelay];
-				break;
-			case 1:
-				xOffset = -torchPosOffset[tickDelay];
-				break;
+			switch (getSideFromMeta(meta)) {
+                case SOUTH:
+				    zOffset = torchPosOffset[tickDelay];
+				    break;
+                case NORTH:
+				    zOffset = -torchPosOffset[tickDelay];
+				    break;
+                case EAST:
+				    xOffset = torchPosOffset[tickDelay];
+				    break;
+                case WEST:
+				    xOffset = -torchPosOffset[tickDelay];
+				    break;
 			}
 		}
 		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, 0, 0, 0, redstoneBrightness);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
index a648a7a60..0752a7321 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
@@ -26,7 +26,7 @@ public class BlockLogicTNT extends BlockLogic {
 
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		if (blockId > 0 && Blocks.blocksList[blockId].isSignalSource() && world.hasNeighborSignal(x, y, z)) {
+		if (blockId > 0 && world.hasNeighborSignal(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index f8d281138..22f21038a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.current.util.BlockPos;
+import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -174,7 +176,8 @@ public class BlockLogicWireRedstone extends BlockLogic {
         if (world.isClientSide) {
             return;
         }
-        updatePowerStrength(world, x, y, z);
+//        updatePowerStrength(world, x, y, z);
+        world.getWireHandler().onWireAdded(new BlockPos(x, y, z));
         world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
         world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
         checkCornerChangeAt(world, x - 1, y, z);
@@ -211,7 +214,8 @@ public class BlockLogicWireRedstone extends BlockLogic {
         }
         world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
         world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
-        updatePowerStrength(world, x, y, z);
+//        updatePowerStrength(world, x, y, z);
+        world.getWireHandler().onWireRemoved(new BlockPos(x, y, z), new BlockState(this.id(), world.getBlockMetadata(x, y, z)));
         checkCornerChangeAt(world, x - 1, y, z);
         checkCornerChangeAt(world, x + 1, y, z);
         checkCornerChangeAt(world, x, y, z - 1);
@@ -249,7 +253,7 @@ public class BlockLogicWireRedstone extends BlockLogic {
 
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-        if (world.isClientSide) {
+        if (world.isClientSide || world.getWireHandler().onWireUpdated(new BlockPos(x, y, z))) {
             return;
         }
 
@@ -289,37 +293,59 @@ public class BlockLogicWireRedstone extends BlockLogic {
         if (side == Side.TOP) {
             return true;
         }
-        boolean negXShouldConnectTo = shouldConnectTo(worldSource, x - 1, y, z, 1) || !worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectTo(worldSource, x - 1, y - 1, z, -1);
-        boolean posXShouldConnectTo = shouldConnectTo(worldSource, x + 1, y, z, 3) || !worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectTo(worldSource, x + 1, y - 1, z, -1);
-        boolean negZShouldConnectTo = shouldConnectTo(worldSource, x, y, z - 1, 2) || !worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectTo(worldSource, x, y - 1, z - 1, -1);
-        boolean posZShouldConnectTo = shouldConnectTo(worldSource, x, y, z + 1, 0) || !worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectTo(worldSource, x, y - 1, z + 1, -1);
+        boolean negXShouldConnectTo = shouldConnectTo(worldSource, x - 1, y, z, Side.WEST) || !worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectToDiagonal(worldSource, x - 1, y - 1, z, Side.NONE, Side.BOTTOM);
+        boolean posXShouldConnectTo = shouldConnectTo(worldSource, x + 1, y, z, Side.EAST) || !worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectToDiagonal(worldSource, x + 1, y - 1, z, Side.NONE, Side.BOTTOM);
+        boolean negZShouldConnectTo = shouldConnectTo(worldSource, x, y, z - 1, Side.NORTH) || !worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectToDiagonal(worldSource, x, y - 1, z - 1, Side.NONE, Side.BOTTOM);
+        boolean posZShouldConnectTo = shouldConnectTo(worldSource, x, y, z + 1, Side.SOUTH) || !worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectToDiagonal(worldSource, x, y - 1, z + 1, Side.NONE, Side.BOTTOM);
         if (!worldSource.isBlockNormalCube(x, y + 1, z)) {
-            if (worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectTo(worldSource, x - 1, y + 1, z, -1)) {
+            if (worldSource.isBlockNormalCube(x - 1, y, z) && shouldConnectToDiagonal(worldSource, x - 1, y + 1, z, Side.NONE, Side.TOP)) {
                 negXShouldConnectTo = true;
             }
-            if (worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectTo(worldSource, x + 1, y + 1, z, -1)) {
+            if (worldSource.isBlockNormalCube(x + 1, y, z) && shouldConnectToDiagonal(worldSource, x + 1, y + 1, z, Side.NONE, Side.TOP)) {
                 posXShouldConnectTo = true;
             }
-            if (worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectTo(worldSource, x, y + 1, z - 1, -1)) {
+            if (worldSource.isBlockNormalCube(x, y, z - 1) && shouldConnectToDiagonal(worldSource, x, y + 1, z - 1, Side.NONE, Side.TOP)) {
                 negZShouldConnectTo = true;
             }
-            if (worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectTo(worldSource, x, y + 1, z + 1, -1)) {
+            if (worldSource.isBlockNormalCube(x, y, z + 1) && shouldConnectToDiagonal(worldSource, x, y + 1, z + 1, Side.NONE, Side.TOP)) {
                 posZShouldConnectTo = true;
             }
         }
-        if (!negZShouldConnectTo && !posXShouldConnectTo && !negXShouldConnectTo && !posZShouldConnectTo && side.getAxis() != Axis.Y) {
-            return true;
-        }
-        if (side == Side.NORTH && negZShouldConnectTo && !negXShouldConnectTo && !posXShouldConnectTo) {
-            return true;
-        }
-        if (side == Side.SOUTH && posZShouldConnectTo && !negXShouldConnectTo && !posXShouldConnectTo) {
-            return true;
-        }
-        if (side == Side.WEST && negXShouldConnectTo && !negZShouldConnectTo && !posZShouldConnectTo) {
-            return true;
+        // Make wire emit block updates when a redirection happens
+        if (worldSource instanceof World) {
+            World world = (World) worldSource;
+
+            int meta = world.getBlockMetadata(x, y, z);
+            int direction = (meta & (15 << 4)) >> 4; // 0b00000000 00000000 00000000 DDDD0000
+
+            int newDirectionNorth = negZShouldConnectTo ? 1 : 0;
+            int newDirectionSouth = (posZShouldConnectTo ? 1 : 0) << 1;
+            int newDirectionWest = (negXShouldConnectTo ? 1 : 0) << 2;
+            int newDirectionEast = (posXShouldConnectTo ? 1 : 0) << 3;
+            int newDirection = newDirectionNorth | newDirectionSouth | newDirectionWest | newDirectionEast;
+
+            if (direction != newDirection) {
+                newDirection <<= 4;
+                meta &= (~(15 << 4)); // Mask out direction bits
+                meta |= newDirection;
+                world.setBlockMetadata(x, y, z, meta);
+            }
         }
-        return side == Side.EAST && posXShouldConnectTo && !negZShouldConnectTo && !posZShouldConnectTo;
+
+
+        boolean isXConnected = posXShouldConnectTo || negXShouldConnectTo;
+        boolean isZConnected = posZShouldConnectTo || negZShouldConnectTo;
+        return !isZConnected && !isXConnected && side.getAxis() != Axis.Y // Default single dust
+            // When the signal request comes from a block that dust connects to (usually power sources)
+            || side == Side.SOUTH && negZShouldConnectTo
+            || side == Side.NORTH && posZShouldConnectTo
+            || side == Side.EAST && negXShouldConnectTo
+            || side == Side.WEST && posXShouldConnectTo
+            // When the signal request comes from the block opposite of a connection (most redstone components)
+            || side == Side.NORTH && negZShouldConnectTo && !isXConnected
+            || side == Side.SOUTH && posZShouldConnectTo && !isXConnected
+            || side == Side.WEST && negXShouldConnectTo && !isZConnected
+            || side == Side.EAST && posXShouldConnectTo && !isZConnected;
     }
 
     @Override
@@ -342,30 +368,30 @@ public class BlockLogicWireRedstone extends BlockLogic {
         world.spawnParticle("reddust", px, py, pz, 0, 0, 0, redstoneBrightness);
     }
 
-    public static boolean shouldConnectTo(WorldSource worldSource, int x, int y, int z, int data) {
-        int blockId = worldSource.getBlockId(x, y, z);
-        if (blockId == Blocks.WIRE_REDSTONE.id()) {
-            return true;
-        }
-        if (blockId <= 0) {
+    public static boolean shouldConnectTo(WorldSource worldSource, int x, int y, int z, Side side) {
+        // TODO make connections handled per block rather then by the dust
+        final Block<?> block = worldSource.getBlock(x, y, z);
+        if (block == null) {
             return false;
         }
-        if (Blocks.blocksList[blockId].isSignalSource()) {
+        if (block == Blocks.WIRE_REDSTONE) {
             return true;
         }
-        if (blockId == Blocks.PUMPKIN_REDSTONE.id()) {
-            if (data < 0 || data > 3) {
-                return false;
-            }
-            Side[] lookup = {Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
-            Side side = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
-            return side == lookup[data];
+        if (block == Blocks.PUMPKIN_REDSTONE) {
+            if (side == Side.NONE || side.isVertical()) return false;
+            return Side.getSideById(worldSource.getBlockMetadata(x, y, z)).getOpposite() == side;
         }
-        if (blockId == Blocks.REPEATER_IDLE.id() || blockId == Blocks.REPEATER_ACTIVE.id()) {
-            int meta = worldSource.getBlockMetadata(x, y, z);
-            return data == BlockLogicBed.footToHeadMap[meta & 0b11];
-        } else {
-            return false;
+        if (block == Blocks.REPEATER_IDLE || block == Blocks.REPEATER_ACTIVE) {
+            final Side direction = BlockLogicRepeater.getSideFromMeta(worldSource.getBlockMetadata(x, y, z));
+            return side == direction || side == direction.getOpposite();
         }
+        return block.isSignalSource();
+    }
+
+    public static boolean shouldConnectToDiagonal(WorldSource worldSource, int x, int y, int z, Side side1, Side side2) {
+        if (!(side2 == Side.TOP || side2 == Side.BOTTOM)) return false; // Maybe some can generate a connection if placed below a block in the future?
+
+        int blockId = worldSource.getBlockId(x, y, z);
+        return blockId == Blocks.WIRE_REDSTONE.id();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 8c0611d23..5ca68761e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -757,6 +757,13 @@ public final class Blocks {
     public static final Block<?> BUTTON_STONE = register("button.stone", "minecraft:block/button_stone", 470, BlockLogicButton::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final Block<?> BUTTON_PLANKS = register("button.planks", "minecraft:block/button_planks", 471, BlockLogicButton::new)
+        .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final Block<BlockLogicButtonPainted> BUTTON_PLANKS_PAINTED = register("button.planks.painted", "minecraft:block/button_planks_painted", 472, BlockLogicButtonPainted::new)
+        .setBlockItem((b) -> new ItemBlockPainted<>(b, true))
+        .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final Block<?> LEVER_COBBLE_STONE = register("lever.cobble.stone", "minecraft:block/lever_cobble_stone", 480, BlockLogicLever::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
@@ -771,6 +778,10 @@ public final class Blocks {
     public static final Block<?> PRESSURE_PLATE_COBBLE_STONE = register("pressureplate.cobble.stone", "minecraft:block/pressure_plate_cobble_stone", 492, (b) -> new BlockLogicPressurePlate<>(b, Player.class, Material.stone))
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final Block<BlockLogicPressurePlatePainted> PRESSURE_PLATE_PLANKS_OAK_PAINTED = register("pressureplate.planks.oak.painted", "minecraft:block/pressure_plate_planks_oak_painted", 493, (BlockLogicSupplier<BlockLogicPressurePlatePainted>)b -> new BlockLogicPressurePlatePainted<>(b, Entity.class, Material.wood))
+        .setBlockItem((b) -> new ItemBlockPainted<>(b, true))
+        .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final Block<BlockLogicMotionSensor> MOTION_SENSOR_IDLE = register("motionsensor.idle", "minecraft:block/motion_sensor_idle", 500, (BlockLogicSupplier<BlockLogicMotionSensor>)(b) -> new BlockLogicMotionSensor(b, false))
         .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.stone)
diff --git a/game/core/src/main/java/net/minecraft/core/current/LICENSE b/game/core/src/main/java/net/minecraft/core/current/LICENSE
new file mode 100644
index 000000000..dee59d479
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/LICENSE
@@ -0,0 +1,21 @@
+MIT License
+
+Copyright (c) 2022 Space Walker
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+SOFTWARE.
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java
new file mode 100644
index 000000000..c79344c05
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java
@@ -0,0 +1,41 @@
+package net.minecraft.core.current.util;
+
+public class BlockPos {
+
+	public final int x;
+	public final int y;
+	public final int z;
+
+	public BlockPos(int x, int y, int z) {
+		this.x = x;
+		this.y = y;
+		this.z = z;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (obj instanceof BlockPos) {
+			BlockPos pos = (BlockPos)obj;
+			return pos.x == x && pos.y == y && pos.z == z;
+		}
+
+		return false;
+	}
+
+	@Override
+	public int hashCode() {
+		return x + 31 * (y + 31 * z);
+	}
+
+	public BlockPos offset(Direction dir) {
+		return offset(dir, 1);
+	}
+
+	public BlockPos offset(Direction dir, int dist) {
+		return offset(dist * dir.offsetX, dist * dir.offsetY, dist * dir.offsetZ);
+	}
+
+	public BlockPos offset(int offsetX, int offsetY, int offsetZ) {
+		return new BlockPos(x + offsetX, y + offsetY, z + offsetZ);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
new file mode 100644
index 000000000..1e87b735c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -0,0 +1,101 @@
+package net.minecraft.core.current.util;
+
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class BlockState {
+
+	public static final BlockState AIR = new BlockState(null, 0) {
+		public int getBlockId() { return 0; }
+		public boolean is(Block<?> block) { return false; }
+		public BlockState set(int metadata) { return this; }
+		public boolean isAir() { return true; }
+		public boolean isConductor() { return false; }
+		public boolean isSignalSource() { return false; }
+		public boolean hasSignal(World world, BlockPos pos, Direction dir) { return false; }
+		public boolean hasDirectSignal(World world, BlockPos pos, Direction dir) { return false; }
+		public boolean canSurvive(World world, BlockPos pos) { return true; }
+		public void dropItems(World world, BlockPos pos) { }
+		public void neighborChanged(World world, BlockPos pos, Block<?> fromBlock) { }
+	};
+
+	private final Block<?> block;
+	private final int metadata;
+
+	public BlockState(int blockId, int metadata) {
+		this(Blocks.getBlock(blockId), metadata);
+	}
+
+	public BlockState(Block<?> block, int metadata) {
+		this.block = block;
+		this.metadata = metadata;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (obj instanceof BlockState) {
+			BlockState state = (BlockState)obj;
+			return state.block == block && state.metadata == metadata;
+		}
+
+		return false;
+	}
+
+	public int getBlockId() {
+		return block.id();
+	}
+
+	public Block<?> getBlock() {
+		return block;
+	}
+
+	public boolean is(Block<?> block) {
+		return this.block == block;
+	}
+
+	public int get() {
+		return metadata;
+	}
+
+	public BlockState set(int metadata) {
+		return new BlockState(block, metadata);
+	}
+
+	public boolean isAir() {
+		return this == AIR;
+	}
+
+	public boolean isConductor() {
+		return block.getMaterial().isSolidBlocking() && block.isSolidRender(); // Would use isCubeShaped, but slabs are cube shaped...
+	}
+
+	public boolean isSignalSource() {
+		return block.isSignalSource();
+	}
+
+	public boolean hasSignal(World world, BlockPos pos, Direction dir) {
+		return block.getSignal(world, pos.x, pos.y, pos.z, Side.getSideById(dir.index));
+	}
+
+	public boolean hasDirectSignal(World world, BlockPos pos, Direction dir) {
+		return block.getDirectSignal(world, pos.x, pos.y, pos.z, Side.getSideById(dir.index));
+	}
+
+	public boolean canSurvive(World world, BlockPos pos) {
+		Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
+		Block<?> underBlock = world.getBlock(pos.x, pos.y - 1, pos.z);
+		return (block == null || block == Blocks.WIRE_REDSTONE || block.getMaterial().isReplaceable()) && underBlock != null && underBlock.isCubeShaped();
+	}
+
+	public void dropItems(World world, BlockPos pos) {
+		block.dropBlockWithCause(world, EnumDropCause.WORLD, pos.x, pos.y, pos.z, 0, null, null);
+	}
+
+	public void neighborChanged(World world, BlockPos pos, Block<?> neighborBlock) {
+		block.onNeighborBlockChange(world, pos.x, pos.y, pos.z, neighborBlock.id());
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockUtil.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockUtil.java
new file mode 100644
index 000000000..8fc442573
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockUtil.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.current.util;
+
+public class BlockUtil {
+
+	public static final int FLAG_UPDATE_CLIENTS = 0b10;
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/Direction.java b/game/core/src/main/java/net/minecraft/core/current/util/Direction.java
new file mode 100644
index 000000000..59884135b
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/Direction.java
@@ -0,0 +1,48 @@
+package net.minecraft.core.current.util;
+
+public enum Direction {
+
+	DOWN(0, 1, 0, -1, 0),
+	UP(1, 0, 0, 1, 0),
+	NORTH(2, 3, 0, 0, -1),
+	SOUTH(3, 2, 0, 0, 1),
+	WEST(4, 5, -1, 0, 0),
+	EAST(5, 4, 1, 0, 0);
+
+	public static final Direction[] ALL;
+
+	static {
+
+		ALL = new Direction[values().length];
+
+		for (Direction dir : values()) {
+			ALL[dir.index] = dir;
+		}
+	}
+
+	public final int index;
+	public final int oppositeIndex;
+	public final int offsetX;
+	public final int offsetY;
+	public final int offsetZ;
+
+	private Direction(int index, int opposite, int offsetX, int offsetY, int offsetZ) {
+		this.index = index;
+		this.oppositeIndex = opposite;
+		this.offsetX = offsetX;
+		this.offsetY = offsetY;
+		this.offsetZ = offsetZ;
+	}
+
+	public static Direction fromIndex(int index) {
+		if (index < 0 || index >= ALL.length) {
+			return null;
+		}
+
+		return ALL[index];
+	}
+
+	public Direction getOpposite() {
+		return ALL[oppositeIndex];
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/Mth.java b/game/core/src/main/java/net/minecraft/core/current/util/Mth.java
new file mode 100644
index 000000000..992f9470f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/Mth.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.current.util;
+
+public class Mth {
+	public static int clamp(int i, int min, int max) {
+		return i <= min ? min : Math.min(i, max);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/Redstone.java b/game/core/src/main/java/net/minecraft/core/current/util/Redstone.java
new file mode 100644
index 000000000..ec470d758
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/util/Redstone.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.current.util;
+
+public class Redstone {
+	public static final int SIGNAL_MIN = 0;
+	public static final int SIGNAL_MAX = 15;
+	public static final int SIGNAL_STEP = 1;
+}
